
'=======================================================
'                                                      '
'            -------------------------                 '
'                  StringMap.inc                       '
'            -------------------------                 '
'                                                      '
'  This include file will let you manipulate strings.  ' 
'                                                      '
'                  By Andy1966.                        '
'                                                      '
'=======================================================


'==================================================
'                   Variables.                    '
'==================================================
window SMWin
int SMCount,SMNewCount
int SMStartDel,SMEndDel
int FirstTextPos,NextTextPos,LastTextPos,SMSearchString
int NextBlockPos
int SMCall    = 0
int SMTrue    = 0 
int SMDebug   = 0
int SMCorrect = 1

type SMCharType
     int CharMatch
endtype

pointer SMChr
SMChr = new(SMCharType,1)
settype SMChr,SMCharType

type TStartType
     int TStart
endtype

pointer TSP 
TSP = new(TStartType,1)
settype TSP,TStartType

type SMaa
     istring aBlock[1024]
endtype

pointer SMab 
SMab = new(SMaa,1)
settype SMab,SMaa

istring SMNewString[5000]

'==================================================
'                   Subroutines.                  '
'==================================================
sub SMSearchText(string SMAstring,string SMDelimiter),int  

    SMBCount(SMAstring,SMDelimiter) 'SMCount text blocks so we can set each pointer size

	 delete SMChr
    SMChr = new(SMCharType,SMNewCount+1)
    settype SMChr,SMCharType

	 delete TSP
	 TSP = new(TStartType,SMNewCount+1)
	 settype TSP,TStartType

    delete SMab
    SMab = new(SMaa,SMNewCount+1)
    settype SMab,SMaa

	 istring SMString2[5000] = ""
	 SMStartDel = 0
	 SMEndDel   = 0
    SMCount    = 0

    SMString2 = SMAstring

    if mid$(SMAstring,1,len(SMDelimiter)) <> SMDelimiter
       SMString2 = SMDelimiter + SMString2
       SMStartDel = 0
    else
       SMStartDel = 1
    endif

    if mid$(SMAstring,len(SMAstring)-(len(SMDelimiter)-1)) <> SMDelimiter
       SMEndDel = 0
    else
       SMEndDel = 1 
    endif  

	 for SMSearchString = 1 to len(SMString2)
		  if mid$(SMString2,SMSearchString,len(SMDelimiter)) = SMDelimiter
			  SMCount ++
		     #SMChr[SMCount-1].CharMatch = SMSearchString
        endif
	 next SMSearchString

	 for SMx = 1 to SMCount

		  int SMStartPos
		  int SMEndPos
		  int SMLength

		  if SMx = 1 and #SMChr[0].CharMatch <> 1
			  #SMab[SMx-1].aBlock = mid$(SMString2,1,#SMChr[0].CharMatch - 1)
		  else
           if SMx <> SMCount
			     SMStartPos = #SMChr[SMx-1].CharMatch + len(SMDelimiter)
			     SMEndPos   = #SMChr[SMx].CharMatch - 1
			     SMLength   = (SMEndPos - SMStartPos) + 1

              #TSP[SMx-1].Tstart = SMStartPos

              if mid$(SMString2,SMStartPos,SMLength) <> ""
                 #SMab[SMx-1].aBlock = mid$(SMString2,SMStartPos,SMLength)
              endif
           else
			     SMStartPos = #SMChr[SMCount-1].CharMatch + len(SMDelimiter)
			     SMEndPos   = #SMChr[SMCount-1].CharMatch + len(SMDelimiter) + len(SMString2)
			     SMLength   = (SMEndPos - SMStartPos) + 1

              #TSP[SMx-1].Tstart = SMStartPos

              if mid$(SMString2,SMStartPos,SMLength) <> ""
                 SMCount ++ 
                 #SMab[SMCount-1].aBlock = mid$(SMString2,SMStartPos,SMLength)
              endif
              breakfor
           endif

		  endif

	 next SMx

	 SMNewCount = 0

	 for SMx = 1 to SMCount
        if SMStartDel = 0  
           #TSP[SMx-1].TStart = #TSP[SMx-1].TStart - len(SMDelimiter)
        endif
 
		  if #SMab[SMx-1].aBlock <> ""
			  SMNewCount ++
			  #SMab[SMNewCount-1].aBlock  = #SMab[SMx-1].aBlock
		  endif
	 next SMx

return SMNewCount
endsub

sub ReplaceDelimiter(string SMAstring,string SMDelimiter,string SMNewDelimiter),string

    istring SMReturnIstring[5000]

    SMSearchText(SMAstring,SMDelimiter)

    SMNewString = ""

    for SMx = 1 to SMNewCount
        SMNewString = SMNewString + SMNewDelimiter + #SMab[SMx-1].aBlock
    next SMx

    SMNewString = SMNewString + SMNewDelimiter

    if mid$(SMAstring,1,len(SMDelimiter)) <> SMDelimiter
       SMNewString = mid$(SMNewString,len(SMNewDelimiter)+1,len(SMNewString))
    endif

    if mid$(SMAstring,(len(SMAstring)-len(SMDelimiter)+1),len(SMAstring)) <> SMDelimiter
       SMNewString = mid$(SMNewString,1,(len(SMNewString)-len(SMNewDelimiter)))
    endif

    SMReturnIstring = SMNewString
return SMReturnIstring
endsub

sub CountBlocks(string SMAstring,string SMDelimiter),int
	 SMCount = 0
	 SMNewCount = SMSearchText(SMAstring,SMDelimiter)
return SMNewCount
endsub

sub GetFirstText(string SMAstring,string SMDelimiter),string 
    istring SMReturnIstring[5000] 
	 SMCount = 0
	 SMSearchText(SMAstring,SMDelimiter)
    FirstTextPos    = #TSP[0].TStart
    SMReturnIstring = #SMab[0].aBlock 
return SMReturnIstring 
endsub

sub GetNextText(string SMAstring,string SMDelimiter,int SMBlockCount),string 
    istring SMReturnIstring[5000]  
	 SMCount = 0
	 SMSearchText(SMAstring,SMDelimiter)
    NextTextPos     = #TSP[SMBlockCount-1].TStart
    SMReturnIstring = #SMab[SMBlockCount-1].aBlock 
return SMReturnIstring
endsub

sub GetLastText(string SMAstring,string SMDelimiter),string  
    istring SMReturnIstring[5000]  
	 SMCount = 0
	 SMSearchText(SMAstring,SMDelimiter)
    LastTextPos     = #TSP[SMNewCount-1].TStart
    SMReturnIstring = #SMab[SMNewCount-1].aBlock 
return SMReturnIstring
endsub

sub SMBCount(string SMAstring,string SMDelimiter),int
    istring SMString2[5000]
    SMString2 = SMAstring

	 for SMSearchString = 1 to len(SMString2)
		  if mid$(SMString2,SMSearchString,len(SMDelimiter)) = SMDelimiter
			  SMCount ++
        endif
	 next SMSearchString

    if mid$(SMString2,1,len(SMDelimiter)) <> SMDelimiter
       SMString2 = SMDelimiter + SMString2
       SMCount ++
    endif

    if mid$(SMString2,len(SMString2)-(len(SMDelimiter)-1)) = SMDelimiter
       SMCount -- 
    endif

    SMNewCount = 0
    SMNewCount = SMCount

return SMNewCount
endsub

sub InstrAll(string SMAstring,string SMSearchInText),int
    int InstrACnt = 0
    int InstrAPos = 0
    SMTrue        = 0
    SMString2 = SMAstring
	 for SMSearchString = 1 to len(SMString2)
		  if mid$(SMString2,SMSearchString,len(SMSearchInText)) = SMSearchInText
           InstrACnt ++
           SMTrue = 1 
        endif
	 next SMSearchString
return InstrACnt
endsub

sub InstrX(string SMAstring,string SMSearchInText,int SMInstance),int
    int InstrCnt = 0
    int InstrPos = 0
    SMString2 = SMAstring
	 for SMSearchString = 1 to len(SMString2)
		  if mid$(SMString2,SMSearchString,len(SMSearchInText)) = SMSearchInText
           InstrCnt ++
           if InstrCnt = SMInstance then return SMSearchString
        endif
	 next SMSearchString
return 0
endsub

sub ReplaceString(string SMAstringIn,string SMSearchInText,int SMInstance,string SMANewText),string
    istring SMReturnIstring[5000]  
    int InstrDCnt = 0
    int InstrECnt = 0
    SMTrue        = 0

    InstrDCnt = InstrAll(SMAstringIn,SMSearchInText)

    if InstrDCnt > 0 
       InstrECnt = SMGetTheStringPos(SMAstringIn,SMSearchInText,SMInstance)
    endif
 
    if InstrECnt = 0 
       SMTrue = 0
       SMReturnIstring = SMAstringIn
       return SMReturnIstring
    endif 

    SMTrue = 1
    SMReturnIstring = SMReplaceString(SMAstringIn,SMSearchInText,SMANewText,SMSearchString)

return SMReturnIstring
endsub

sub ReplaceFirstString(string SMAstringIn,string SMSearchInText,string SMANewText),string
    istring SMReturnIstring[5000]  
    int InstrDCnt = 0
    int InstrECnt = 0
    SMTrue        = 0

    InstrDCnt = InstrAll(SMAstringIn,SMSearchInText)

    if InstrDCnt > 0 
       InstrECnt = SMGetTheStringPos(SMAstringIn,SMSearchInText,1)
    endif
 
    if InstrECnt = 0 
       SMTrue = 0
       SMReturnIstring = SMAstringIn
       return SMReturnIstring
    endif 

    SMTrue = 1
    SMReturnIstring = SMReplaceString(SMAstringIn,SMSearchInText,SMANewText,SMSearchString)

return SMReturnIstring
endsub

sub ReplaceLastString(string SMAstringIn,string SMSearchInText,string SMANewText),string
    istring SMReturnIstring[5000]  
    int InstrDCnt = 0
    int InstrECnt = 0
    SMTrue        = 0

    InstrDCnt = InstrAll(SMAstringIn,SMSearchInText)

    if InstrDCnt > 0 
       InstrECnt = SMGetTheStringPos(SMAstringIn,SMSearchInText,InstrDCnt)
    endif
 
    if InstrECnt = 0 
       SMTrue = 0
       SMReturnIstring = SMAstringIn
       return SMReturnIstring
    endif 

    SMTrue = 1
    SMReturnIstring = SMReplaceString(SMAstringIn,SMSearchInText,SMANewText,SMSearchString)

return SMReturnIstring
endsub

sub ReplaceAllStrings(string SMAstring,string SMSearchInText,string SMANewText),string
    istring SMReturnIstring[5000]  
    int InstrBCnt = 0
    SMTrue        = 0

    SMReturnIstring = SMAstring

    label looproundagain 
    InstrBCnt = InstrAll(SMReturnIstring,SMSearchInText)

    if InstrBCnt = 0 
       SMTrue = 0
       SMReturnIstring = SMAstring
       return SMReturnIstring
    endif    

    for SMx = 1 to InstrBCnt 
        SMReturnIstring = ReplaceString(SMReturnIstring,SMSearchInText,1,SMANewText)
    next SMx

    SMTrue = 1

return SMReturnIstring
endsub

Sub ReplaceStringBetween(string SMAstringIn,string SMSearchInText1,int SMBin1,string SMSearchInText2,int SMBin2,string SMReplaceWith),string
    istring SMReturnIstringB[5000]  
    istring SMReturnIstringC[5000]
    istring SMReturnIstringX[5000]
    int SMtext1C = 0
    int SMText2c = 0 

    SMCall = 2

    if SMDebug = 1
       SMBin1 = SMCheckValuesI1(SMAstringIn,SMSearchInText1,SMBin1)
       SMBin2 = SMCheckValuesI2(SMAstringIn,SMSearchInText2,SMBin2)
       SMCheckValues(SMAstringIn,SMSearchInText1,SMBin1,SMSearchInText2,SMBin2)
       if SMSearchInText1 <> SMSearchInText2
          SMCheckPositions(SMAstringIn,SMSearchInText1,SMBin1,SMSearchInText2,SMBin2)
       endif 
    else
       SMBin1 = SMCheckValuesI1(SMAstringIn,SMSearchInText1,SMBin1)
       SMBin2 = SMCheckValuesI2(SMAstringIn,SMSearchInText2,SMBin2)
    endif

	 SMText1C = InstrAll(SMAstringIn,SMSearchInText1)
	 SMText2C = InstrAll(SMAstringIn,SMSearchInText2)

	 if SMText1C < SMBin1
		 SMBin1 = SMText1C
	 endif

	 if SMText2C < SMBin2
		 SMBin2 = SMText2C
	 endif

    SMReturnIstringB = GetBeforeString(SMAstringIn,SMSearchInText1,SMBin1)

    if SMTrue
       SMReturnIstringC = GetAfterString(SMAstringIn,SMSearchInText2,SMBin2)
       if SMTrue
          SMReturnIstringX = SMReturnIstringB + SMReplaceWith + SMReturnIstringC
          SMCall = 0 
          return SMReturnIstringX
       endif
    endif

    SMCall = 0
    SMReturnIstringX = ""

return SMReturnIstringX
endsub



Sub ReplaceStringFrom(string SMAstringIn,string SMSearchInText1,int SMBin1,string SMSearchInText2,int SMBin2,string SMReplaceWith),string
    istring SMReturnIstringB[5000]  
    istring SMReturnIstringC[5000]
    istring SMReturnIstringX[5000]
    int SMtext1C = 0
    int SMText2c = 0 

    SMCall = 2

    if SMDebug = 1
       SMBin1 = SMCheckValuesI1(SMAstringIn,SMSearchInText1,SMBin1)
       SMBin2 = SMCheckValuesI2(SMAstringIn,SMSearchInText2,SMBin2)
       SMCheckValues(SMAstringIn,SMSearchInText1,SMBin1,SMSearchInText2,SMBin2)
       if SMSearchInText1 <> SMSearchInText2
          SMCheckPositions(SMAstringIn,SMSearchInText1,SMBin1,SMSearchInText2,SMBin2)
       endif 
    else
       SMBin1 = SMCheckValuesI1(SMAstringIn,SMSearchInText1,SMBin1)
       SMBin2 = SMCheckValuesI2(SMAstringIn,SMSearchInText2,SMBin2)
    endif

	 SMText1C = InstrAll(SMAstringIn,SMSearchInText1)
	 SMText2C = InstrAll(SMAstringIn,SMSearchInText2)

	 if SMText1C < SMBin1
		 SMBin1 = SMText1C
	 endif

	 if SMText2C < SMBin2
		 SMBin2 = SMText2C
	 endif

    SMReturnIstringB = GetBeforeString(SMAstringIn,SMSearchInText1,SMBin1) + SMSearchInText1

    if SMTrue
       SMReturnIstringC = GetAfterString(SMAstringIn,SMSearchInText2,SMBin2)
       if SMTrue
          SMReturnIstringX = SMReturnIstringB + SMReplaceWith + SMSearchInText2 + SMReturnIstringC 
          SMCall = 0 
          return SMReturnIstringX
       endif
    endif

    SMCall = 0
    SMReturnIstringX = ""

return SMReturnIstringX
endsub





sub SMReplaceString(string SMAstringIn,string SMSearchInText,string SMANewText,INT SMSearchStringIn),string
    istring SMReturnIstringA[5000]  
    istring SMBeforeChangeA[5000]
    istring SMAfterChangeA[5000]

    SMBeforeChangeA  = mid$(SMAstringIn,1,(SMSearchStringIn-1))
    SMAfterChangeA   = mid$(SMAstringIn,(SMSearchStringIn+len(SMSearchInText)),len(SMAstringIn))
    SMReturnIstringA = SMBeforeChangeA + SMANewText + SMAfterChangeA

return SMReturnIstringA
endsub

sub SMGetTheStringPos(string SMAstringIn,string SMSearchInText,int SMSearchNo),int
    int InstrDCnt = 0
    int InstrPos  = 0

    InstrDCnt = InstrAll(SMAstringIn,SMSearchInText)

    if InstrDCnt > 0
       InstrECnt = InstrX(SMAstringIn,SMSearchInText,SMSearchNo)
    endif

    InstrPos = InstrECnt

return InstrPos
endsub

sub GetNextInst(string SMAstringIn,string SMSearchInText,int SMInst),string
    istring SMReturnIstring[5000]  
    int InstrDCnt = 0
    int InstrECnt = 0
    NextBlockPos  = 0
    SMTrue        = 0

    InstrDCnt = InstrAll(SMAstringIn,SMSearchInText)

    if InstrDCnt > 0 
       InstrECnt = SMGetTheStringPos(SMAstringIn,SMSearchInText,SMInst)
       NextBlockPos = InstrECnt
       SMTrue = 1
    endif

    if InstrECnt = 0
       SMTrue = 0
       SMReturnIstring = ""
       return SMReturnIstring
    endif

    SMReturnIstring = mid$(SMAstringIn,InstrECnt,len(SMSearchInText))

return SMReturnIstring
endsub

Sub GetBeforeString(string SMAstringIn,string SMSearchInText,int SMBin),string
    istring SMReturnIstringB[5000]
    int SMExist = 0  

    SMExist = InstrAll(SMAstringIn,SMSearchInText)

    if SMExist = 0
       if SMDebug = 1
		    Messagebox (SMWin,"The search string " + SMSearchInText + " (parameter 2) does not exist in the string.","GetBeforeString command.",@MB_OK|@mb_iconexclamation)
       endif
       SMTrue = 0
       SMReturnIstringB = ""
       return SMReturnIstringB
    endif

    if SMTrue =1
       SMCall = 3
       SMBin = SMCheckValuesI1(SMAstringIn,SMSearchInText,SMBin)
       SMCall = 0
       GetNextInst(SMAstringIn,SMSearchInText,SMBin)
       SMReturnIstringB = mid$(SMAstringIn,1,NextBlockPos-1)
    else
       SMTrue = 0 
       SMReturnIstringB = ""
    endif

return SMReturnIstringB
endsub

Sub GetAfterString(string SMAstringIn,string SMSearchInText,int SMBin),string
    istring SMReturnIstringB[5000] 
    int SMExist = 0  

    SMExist = InstrAll(SMAstringIn,SMSearchInText)

    if SMExist = 0
       if SMDebug = 1
		    Messagebox (SMWin,"The search string " + SMSearchInText + " (parameter 2) does not exist in the string.","GetAfterString command.",@MB_OK|@mb_iconexclamation)
       endif
       SMTrue = 0
       SMReturnIstringB = ""
       return SMReturnIstringB
    endif

    if SMTrue = 1
       SMCall = 4
       SMBin = SMCheckValuesI1(SMAstringIn,SMSearchInText,SMBin)
       SMCall = 0
       GetNextInst(SMAstringIn,SMSearchInText,SMBin)
       SMReturnIstringB = mid$(SMAstringIn,NextBlockPos+len(SMSearchInText),len(SMAstringIn))
    else
       SMTrue = 0
       SMReturnIstringB = ""
    endif

return SMReturnIstringB
endsub  

Sub GetStringBetween(string SMAstringIn,string SMSearchInText1,int SMBin1,string SMSearchInText2,int SMBin2),string
    istring SMReturnIstringB[5000]  
    istring SMReturnIstringC[5000]
    int SMIntCount = 0
    INT SMText1C   = 0
    int SMText2C   = 0

    if SMDebug = 1
       SMBin1 = SMCheckValuesI1(SMAstringIn,SMSearchInText1,SMBin1)
       SMBin2 = SMCheckValuesI2(SMAstringIn,SMSearchInText2,SMBin2)
       SMCheckValues(SMAstringIn,SMSearchInText1,SMBin1,SMSearchInText2,SMBin2)
       if SMSearchInText1 <> SMSearchInText2
          SMCheckPositions(SMAstringIn,SMSearchInText1,SMBin1,SMSearchInText2,SMBin2)
       endif 
    else
       SMBin1 = SMCheckValuesI1(SMAstringIn,SMSearchInText1,SMBin1)
       SMBin2 = SMCheckValuesI2(SMAstringIn,SMSearchInText2,SMBin2)
    endif

    int GetStringFromInstP1 = 0
    GetStringFromInstP1 = InstrX(SMAstringIn,SMSearchInText1,SMBin1)

    int GetStringFromInstP2 = 0
    GetStringFromInstP2 = InstrX(SMAstringIn,SMSearchInText2,SMBin2)

    if GetStringFromInstP1 = 0
       SMTrue = 0
       SMReturnIstringC = ""
       return SMReturnIstringC 
    endif

    if GetStringFromInstP2 = 0
       SMTrue = 0
       SMReturnIstringC = ""
       return SMReturnIstringC 
    endif

    if GetStringFromInstP2 < GetStringFromInstP1
       SMTrue = 0
       SMReturnIstringC = ""
       return SMReturnIstringC 
    endif

    if SMCorrect = 1
	    SMText1C = InstrAll(SMAstringIn,SMSearchInText1)
       if SMText1C < SMBin1
	       SMBin1 = SMText1C
       endif

	    SMText2C = InstrAll(SMAstringIn,SMSearchInText2)
       if SMText2C < SMBin2
	       SMBin2 = SMText2C
       endif
	 endif

    GetStringFromInst = 0
    GetStringFromInst = InstrX(SMAstringIn,SMSearchInText1,SMBin1)

    if GetStringFromInst = 0
       SMTrue = 0 
       SMReturnIstringC = SMAstringIn
       Return SMReturnIstringC 
    endif

    GetStringFromInst = 0
    GetStringFromInst = InstrX(SMAstringIn,SMSearchInText2,SMBin2)

    if GetStringFromInst = 0
       SMTrue = 0 
       SMReturnIstringC = SMAstringIn
       Return SMReturnIstringC 
    endif

	 if SMSearchInText1 = SMSearchInText2
       SMIntCount = InstrAll(SMAstringIn,SMSearchInText1)
       SMBin2 = SMBin2-SMBin1
    endif

    GetNextInst(SMAstringIn,SMSearchInText1,SMBin1)
    SMReturnIstringB = mid$(SMAstringIn,NextBlockPos+len(SMSearchInText1),len(SMAstringIn))

    if SMSearchInText1 = SMSearchInText2 
       GetNextInst(SMReturnIstringB,SMSearchInText2,SMBin2)
       SMReturnIstringC = mid$(SMReturnIstringB,1,NextBlockPos-1)
    else
       int SMMove,SMMove2,SMMove3
       SMMove = 0
       SMMove2 = 0
       SMMove3 = 0

       SMMove = InstrAll(SMAstringIn,SMSearchInText2)
       SMMove2 = InstrAll(SMReturnIstringB,SMSearchInText2)
       SMMove3 = SMMove-SMMove2 
       SMBin2 = SMBin2 - SMMove3
       SMMove2 = InstrX(SMReturnIstringB,SMSearchInText2,SMBin2)
       SMReturnIstringC = mid$(SMReturnIstringB,1,SMMove2-1)
    endif

return SMReturnIstringC
endsub  

Sub GetStringFrom(string SMAstringIn,string SMSearchInText1,int SMBin1,string SMSearchInText2,int SMBin2),string
    istring SMReturnIstringB[5000]  
    istring SMReturnIstringC[5000]
    int GetStringFromInst = 0
    
    SMCall = 1

    GetStringFromInst = InstrX(SMAstringIn,SMSearchInText1,SMBin1)

    if SMDebug = 1
       SMBin1 = SMCheckValuesI1(SMAstringIn,SMSearchInText1,SMBin1)
       SMBin2 = SMCheckValuesI2(SMAstringIn,SMSearchInText2,SMBin2)
       SMStringCheck(SMAstringIn,SMSearchInText1,SMBin1,SMSearchInText2,SMBin2)
    else
       SMBin1 = SMCheckValuesI1(SMAstringIn,SMSearchInText1,SMBin1)
       SMBin2 = SMCheckValuesI2(SMAstringIn,SMSearchInText2,SMBin2)
    endif    

    if GetStringFromInst = 0
       SMTrue = 0 
       SMReturnIstringC = SMAstringIn
       Return SMReturnIstringC 
    endif

    GetStringFromInst = 0
    GetStringFromInst = InstrX(SMAstringIn,SMSearchInText2,SMBin2)

    if GetStringFromInst = 0
       SMTrue = 0 
       SMReturnIstringC = SMAstringIn
       Return SMReturnIstringC 
    endif

    SMReturnIstringB = GetStringBetween(SMAstringIn,SMSearchInText1,SMBin1,SMSearchInText2,SMBin2)
    SMReturnIstringC = SMSearchInText1 + SMReturnIstringB + SMSearchInText2
    SMTrue = 1
    SMCall = 0
return SMReturnIstringC
endsub  

sub EndStringMap(),int
	 delete SMChr
	 delete TSP
    delete SMab
return 0
endsub

sub SMCheckValues(string SMAstringIn,string SMSearchInText1,int SMBin1,string SMSearchInText2,int SMBin2)
    string SMError = ""
    INT SMText1C   = 0
    int SMText2C   = 0

    if SMCall = 0
		 SMError = "GetStringBetween command."
	 endif

	 if SMCall = 1
		 SMError = "GetStringFrom command."
	 endif

    if SMCall = 2
		 SMError = "ReplaceStringBetween command."
	 endif

	 if SMBin1 < 1
		 Messagebox (SMWin, "The first instance number (parameter 3) must be greater than zero.",SMError,@MB_OK|@MB_ICONSTOP)
		 EndStringMap()
		 end
	 endif

	 if SMBin2 < 1
		 Messagebox (SMWin, "The second instance number (parameter 5) must be greater than zero.",SMError,@MB_OK|@MB_ICONSTOP)
		 EndStringMap()
		 end
	 endif

	 if SMBin1 = SMBin2 and SMSearchInText1 = SMSearchInText2
		 Messagebox (SMWin, "The instance numbers are the same.\n\n The second instance number (parameter 5) must be greater than the first (parameter 3).",SMError,@MB_OK|@MB_ICONSTOP)
		 EndStringMap()
		 end
	 endif

	 if SMBin1 > SMBin2 and SMSearchInText1 = SMSearchInText2
		 Messagebox (SMWin, "The first instance number (parameter 3) is greater than the second one (parameter 5)."+ "\n\n" + " parameter 2 of " + SMError ,SMError,@MB_OK|@MB_ICONSTOP)
		 EndStringMap()
		 end
	 endif

	 if SMBin1 < 1
		 Messagebox (SMWin,"Search instance (parameter 3) cannot be less than 1.",SMError,@MB_OK|@MB_ICONSTOP)
		 EndStringMap()
		 end
	 endif

	 SMText1C = InstrAll(SMAstringIn,SMSearchInText1)

	 if SMText1C = 0
		 Messagebox (SMWin, SMSearchInText1 + " does not exists in the string (parameter 2).",SMError,@MB_OK|@MB_ICONSTOP)
		 EndStringMap()
		 end
	 endif

	 if SMBin2 < 1
		 Messagebox (SMWin,"Search instance (parameter 5) cannot be less than 1.",SMError,@MB_OK|@MB_ICONSTOP)
		 EndStringMap()
		 end
	 endif

	 SMText2C = InstrAll(SMAstringIn,SMSearchInText2)

	 if SMText2C = 0
		 Messagebox (SMWin, SMSearchInText2 + " (parameter 4) does not exists in the string.",SMError,@MB_OK|@MB_ICONSTOP)
		 EndStringMap()
		 end
	 endif

return 0
endsub

sub SMCheckValuesI1(string SMAstringIn,string SMSearchInText1,int SMBin1),int 

    string SMError = ""
    INT SMText1C   = 0

    if SMCall = 0
		 SMError = "GetStringBetween command."
	 endif

	 if SMCall = 1
		 SMError = "GetStringFrom command."
	 endif

    if SMCall = 2
		 SMError = "ReplaceStringBetween command."
	 endif

    if SMCall = 3
		 SMError = "GetBeforeString command."
	 endif

    if SMCall = 4
		 SMError = "GetAfterString command."
	 endif

	 SMText1C = InstrAll(SMAstringIn,SMSearchInText1)

	 if SMText1C < SMBin1 and SMText1C > 0
       if SMCorrect = 1
		    SMBin1 = SMText1C
       endif
       if SMDebug = 1 and SMCorrect = 1
		    Messagebox (SMWin, "The are only " + ltrim$(str$(SMText1C)) + " instance(s) for " + SMSearchInText1 + ", (parameter 3).\n\n Instance search value changed to " + ltrim$(str$(SMText1C))+".",SMError,@MB_OK|@mb_iconexclamation)
       endif
       if SMDebug = 1 and SMCorrect = 0
		    Messagebox (SMWin, "The are only " + ltrim$(str$(SMText1C)) + " instance(s) for " + SMSearchInText1 + ", (parameter 3).",SMError,@MB_OK|@mb_iconexclamation)
       endif
    else
       SMTrue = 0
	 endif

return SMBin1
endsub

sub SMCheckValuesI2(string SMAstringIn,string SMSearchInText2,int SMBin2),int

    string SMError = ""
    INT SMText1C   = 0

    if SMCall = 0
		 SMError = "GetStringBetween command."
	 endif

	 if SMCall = 1
		 SMError = "GetStringFrom command."
	 endif

    if SMCall = 2
		 SMError = "ReplaceStringBetween command."
	 endif

	 SMText2C = InstrAll(SMAstringIn,SMSearchInText2)

	 if SMText2C < SMBin2 and SMText2C > 0
       if SMCorrect = 1
		    SMBin2 = SMText2C
       endif
       if SMDebug = 1 and SMCorrect = 1
		    Messagebox (SMWin, "The are only " + ltrim$(str$(SMText2C)) + " instance(s) for " + SMSearchInText2 + ", (parameter 5).\n\n Instance search value changed to " + ltrim$(str$(SMText2C))+".",SMError,@MB_OK|@mb_iconexclamation)
       endif
       if SMDebug = 1 and SMCorrect = 0
		    Messagebox (SMWin, "The are only " + ltrim$(str$(SMText2C)) + " instance(s) for " + SMSearchInText2 + ", (parameter 5).",SMError,@MB_OK|@mb_iconexclamation)
       endif
    else
       SMTrue = 0
	 endif

return SMBin2
endsub

sub SMStringCheck(string SMAstringIn,string SMSearchInText1,int SMBin1,string SMSearchInText2,int SMBin2),string
    istring SMReturnIstringC[5000]
    string SMError = ""

	 SMError = "GetStringFrom command."

    GetStringFromInst = 0
    GetStringFromInst = InstrX(SMAstringIn,SMSearchInText1,SMBin1)

    if GetStringFromInst = 0
       SMTrue = 0 
       SMReturnIstringC = SMAstringIn
		 Messagebox (SMWin,"The search string " + SMSearchInText1 + " (parameter 2) does not exist in the string.",SMError,@MB_OK|@mb_iconexclamation)
       Return SMReturnIstringC 
    endif

    GetStringFromInst = 0
    GetStringFromInst = InstrX(SMAstringIn,SMSearchInText2,SMBin2)

    if GetStringFromInst = 0
       SMTrue = 0 
       SMReturnIstringC = SMAstringIn
		 Messagebox (SMWin,"The search string " + SMSearchInText2 + " (parameter 4) does not exist in the string.",SMError,@MB_OK|@mb_iconexclamation)
       Return SMReturnIstringC 
    endif
return 0
endsub

sub SMCheckPositions(string SMAstringIn,string SMSearchInText1,int SMBin1,string SMSearchInText2,int SMBin2),string
    istring SMReturnIstringC[5000]
    string SMError = ""

	 SMError = "GetStringBetween command."

    int GetStringFromInstP1 = 0
    GetStringFromInstP1 = InstrX(SMAstringIn,SMSearchInText1,SMBin1)

    int GetStringFromInstP2 = 0
    GetStringFromInstP2 = InstrX(SMAstringIn,SMSearchInText2,SMBin2)

    if GetStringFromInstP2 < GetStringFromInstP1
       SMTrue = 0
       SMReturnIstringC = ""
		 Messagebox (SMWin,"The search string " + SMSearchInText2 + " (parameter 4) comes before "  + SMSearchInText1 + " (parameter 2) in the string.",SMError,@MB_OK|@mb_iconexclamation)
       return SMReturnIstringC 
    endif

return SMReturnIstringC
endsub

